package getstars;

import java.awt.Graphics;

public class Barrier extends Entity {

	public Barrier(Pos pos, Board board) {
		super(pos, 2, board);
	}
	
	@Override
	public boolean conflictsWith(Entity entity) {
		if (entity instanceof Barrier) {
			return (getPos().getX() + 3 >= entity.getPos().getX() && entity.getPos().getX() + 3 > getPos().getX()
					&& getPos().getY() + 3 >= entity.getPos().getY() && entity.getPos().getY() + 3 > getPos().getY());
		} else {
			return super.conflictsWith(entity);
		}
	}
	
	@Override
	public void tick() {
		// Do nothing.
	}

	@Override
	public void draw(CustomPanel panel, Graphics graphics) {
		Pos tempPos = getPos().copy();
		panel.drawSprite(graphics, tempPos, 8);
		tempPos.setX(tempPos.getX() + 1);
		panel.drawSprite(graphics, tempPos, 8);
		tempPos.setY(tempPos.getY() + 1);
		panel.drawSprite(graphics, tempPos, 8);
		tempPos.setX(tempPos.getX() - 1);
		panel.drawSprite(graphics, tempPos, 8);
	}

}
