package getstars;

import java.awt.Graphics;

public abstract class Entity {

	private Pos pos;
	private int size;
	private Board board;
	private boolean shouldBeRemoved = false;
	
	public Entity(Pos inputPos, int inputSize, Board inputBoard) {
		pos = inputPos;
		size = inputSize;
		board = inputBoard;
	}
	
	public Pos getPos() {
		return pos;
	}
	
	public int getSize() {
		return size;
	}
	
	public Board getBoard() {
		return board;
	}
	
	public boolean getShouldBeRemoved() {
		return shouldBeRemoved;
	}
	
	public void setShouldBeRemoved(boolean inputShouldBeRemoved) {
		shouldBeRemoved = inputShouldBeRemoved;
	}
	
	public boolean intersectsWith(Pos inputPos) {
		return (inputPos.getX() >= pos.getX() && inputPos.getX() < pos.getX() + size && inputPos.getY() >= pos.getY() && inputPos.getY() < pos.getY() + size);
	}
	
	public boolean conflictsWith(Entity entity) {
		return (pos.getX() + size >= entity.getPos().getX() && entity.getPos().getX() + entity.getSize() > pos.getX()
				&& pos.getY() + size >= entity.getPos().getY() && entity.getPos().getY() + entity.getSize() > pos.getY());
	}
	
	public abstract void tick();
	
	public abstract void draw(CustomPanel panel, Graphics graphics);
	
}
