package getstars;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JFrame;
import javax.swing.Timer;

public class Main {

	private static Board board;
	private static JFrame frame;
	private static CustomPanel panel;
	
	public static void main(String[] args) {
		board = new Board();
		frame = new JFrame("GET STARS");
		panel = new CustomPanel(board);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		Insets insets = frame.getInsets();
		frame.setSize(insets.left + insets.right + panel.getWidth(),
				insets.top + insets.bottom + panel.getHeight());
		frame.setContentPane(panel);
		frame.setVisible(true);
		ActionListener actionListener = new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				board.tick();
				panel.repaint();
			}
		};
		Timer timer = new Timer(50, actionListener);
		timer.start();
		KeyListener keyListener = new KeyListener() {
			public void keyPressed(KeyEvent actionEvent) {
				int keyCode = actionEvent.getKeyCode();
				//System.out.println(keyCode);
				Player tempPlayer = board.getPlayer();
				// A.
				if (keyCode == 65 || keyCode == 37) {
					tempPlayer.startWalking(new Pos(-1, 0));
				}
				// D.
				if (keyCode == 68 || keyCode == 39) {
					tempPlayer.startWalking(new Pos(1, 0));
				}
				// W.
				if (keyCode == 87 || keyCode == 38) {
					tempPlayer.startWalking(new Pos(0, -1));
				}
				// S.
				if (keyCode == 83 || keyCode == 40) {
					tempPlayer.startWalking(new Pos(0, 1));
				}
				// T.
				if (keyCode == 84) {
					board.setTiredMode(!board.getTiredMode());
				}
			}
			public void keyReleased(KeyEvent actionEvent) {
				int keyCode = actionEvent.getKeyCode();
				Player tempPlayer = board.getPlayer();
				if (!board.getTiredMode()) {
					// A.
					if (keyCode == 65 || keyCode == 37) {
						tempPlayer.stopWalking(new Pos(-1, 0));
					}
					// D.
					if (keyCode == 68 || keyCode == 39) {
						tempPlayer.stopWalking(new Pos(1, 0));
					}
					// W.
					if (keyCode == 87 || keyCode == 38) {
						tempPlayer.stopWalking(new Pos(0, -1));
					}
					// S.
					if (keyCode == 83 || keyCode == 40) {
						tempPlayer.stopWalking(new Pos(0, 1));
					}
				}
			}
			public void keyTyped(KeyEvent actionEvent) {
				// Do nothing.
			}
		};
		frame.addKeyListener(keyListener);
	}

}
